/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.kandidatenportal.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WVP_WAHLVORSCHLAG_DATEN.CountWvpBenutzer",
     query="SELECT count(o) FROM WvpWahlvorschlagDaten o WHERE o.wvpBenutzer = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                                
         ,   @javax.persistence.NamedQuery(
     name="WVP_WAHLVORSCHLAG_DATEN.DateiImportOrderByDatenuebernahmeZeitpunktDesc",
     query="SELECT o FROM WvpWahlvorschlagDaten o WHERE o.dateiImport = ?1 order by o.datenuebernahmeZeitpunkt desc",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="WVP_WAHLVORSCHLAG_DATEN.Wahl",
     query="SELECT o FROM WvpWahlvorschlagDaten o WHERE o.wvpBenutzer.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="WVP_WAHLVORSCHLAG_DATEN.WvpBenutzerOrderByDatenuebernahmeZeitpunktDesc",
     query="SELECT o FROM WvpWahlvorschlagDaten o WHERE o.wvpBenutzer = ?1 order by o.datenuebernahmeZeitpunkt desc",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WVP_WAHLVORSCHLAG_DATEN")
// @javax.persistence.IdClass(WvpWahlvorschlagDatenPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class WvpWahlvorschlagDaten
implements WvpWahlvorschlagDatenBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public WvpWahlvorschlagDaten() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WvpWahlvorschlagDaten(WvpWahlvorschlagDaten original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wvp_wahlvorschlag_daten_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "WvpWahlvorschlagDaten")
    @javax.persistence.TableGenerator(name = "WvpWahlvorschlagDaten", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "WvpWahlvorschlagDaten", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WvpWahlvorschlagDatenPK pkCache;

  @Override
  public WvpWahlvorschlagDatenPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WvpWahlvorschlagDatenPK(getId());
    }

    return pkCache;
  }

  public static <E extends WvpWahlvorschlagDaten> java.util.Map<WvpWahlvorschlagDatenPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WvpWahlvorschlagDatenPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends WvpWahlvorschlagDaten> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBericht = false;
          hasChangedDaten = false;
          hasChangedDatenuebernahmeVersion = false;
          hasChangedDatenuebernahmeZeitpunkt = false;
  
      hasChangedDateiImport = false;
        hasChangedWvpBenutzer = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
  @javax.persistence.Column(name = "BERICHT", nullable = WvpWahlvorschlagDatenConstants.BERICHT_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String bericht =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBericht = false;

  public boolean hasChangedBericht(){
    return hasChangedBericht;
  }
  
  /**
   * 
   *
   * getter for WVP_WAHLVORSCHLAG_DATEN.BERICHT
   *
   * (LAZY LOADING)
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBericht() {
        return bericht;
      }

  /**
   * 
   *
   * setter for WVP_WAHLVORSCHLAG_DATEN.BERICHT
   *
   * @param bericht
   */
  @Override   public void setBericht(@javax.annotation.Nullable  java.lang.String bericht) {

       resetTkCache();
                  java.lang.String berichtInternal = org.apache.commons.lang3.StringUtils.trimToNull(bericht);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bericht
      , berichtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBericht |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bericht");
      }


      

       this.bericht = berichtInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "DATEN", nullable = WvpWahlvorschlagDatenConstants.DATEN_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String daten =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDaten = false;

  public boolean hasChangedDaten(){
    return hasChangedDaten;
  }
  
  /**
   * 
   *
   * getter for WVP_WAHLVORSCHLAG_DATEN.DATEN
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getDaten() {
        return daten;
      }

  /**
   * 
   *
   * setter for WVP_WAHLVORSCHLAG_DATEN.DATEN
   *
   * @param daten
   */
  @Override   public void setDaten( java.lang.String daten) {

       resetTkCache();
                  java.lang.String datenInternal = org.apache.commons.lang3.StringUtils.trimToNull(daten);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.daten
      , datenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDaten |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("daten");
      }


      

       this.daten = datenInternal;

         }

        
      @javax.persistence.Column(name = "DATENUEBERNAHME_VERSTION", nullable = WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_VERSTION_NULLABLE, precision=WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_VERSTION_PRECISION, scale=WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_VERSTION_SCALE)
            
  protected java.lang.Long datenuebernahmeVersion =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDatenuebernahmeVersion = false;

  public boolean hasChangedDatenuebernahmeVersion(){
    return hasChangedDatenuebernahmeVersion;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDatenuebernahmeVersion = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenDatenuebernahmeVersion;
  
  /**
   * 
   *
   * getter for WVP_WAHLVORSCHLAG_DATEN.DATENUEBERNAHME_VERSTION
   */
    @Override   public  java.lang.Long getDatenuebernahmeVersion() {
        return datenuebernahmeVersion;
      }

  /**
   * 
   *
   * setter for WVP_WAHLVORSCHLAG_DATEN.DATENUEBERNAHME_VERSTION
   *
   * @param datenuebernahmeVersion
   */
  @Override   public void setDatenuebernahmeVersion( java.lang.Long datenuebernahmeVersion) {

       resetTkCache();
                  java.lang.Long datenuebernahmeVersionInternal = datenuebernahmeVersion;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datenuebernahmeVersion
      , datenuebernahmeVersionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDatenuebernahmeVersion |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("datenuebernahmeVersion");
      }


             if (!isSeitLadenVeraendertDatenuebernahmeVersion) {
          isSeitLadenVeraendertDatenuebernahmeVersion = thisAttributChanged;
         if (isSeitLadenVeraendertDatenuebernahmeVersion){
           wertNachLadenDatenuebernahmeVersion=this.datenuebernahmeVersion;
         }
       }
      

       this.datenuebernahmeVersion = datenuebernahmeVersionInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "DATENUEBERNAHME_ZEITPUNKT", nullable = WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_ZEITPUNKT_NULLABLE, precision=WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_ZEITPUNKT_PRECISION)
    
  protected java.util.Date datenuebernahmeZeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDatenuebernahmeZeitpunkt = false;

  public boolean hasChangedDatenuebernahmeZeitpunkt(){
    return hasChangedDatenuebernahmeZeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDatenuebernahmeZeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenDatenuebernahmeZeitpunkt;
  
  /**
   * 
   *
   * getter for WVP_WAHLVORSCHLAG_DATEN.DATENUEBERNAHME_ZEITPUNKT
   */
    @Override   public  java.util.Date getDatenuebernahmeZeitpunkt() {
              if (datenuebernahmeZeitpunkt == null){
            return null;
          } else {
                          return datenuebernahmeZeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for WVP_WAHLVORSCHLAG_DATEN.DATENUEBERNAHME_ZEITPUNKT
   *
   * @param datenuebernahmeZeitpunkt
   */
  @Override   public void setDatenuebernahmeZeitpunkt( java.util.Date datenuebernahmeZeitpunkt) {

       resetTkCache();
                  java.util.Date datenuebernahmeZeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(datenuebernahmeZeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datenuebernahmeZeitpunkt
      , datenuebernahmeZeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDatenuebernahmeZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("datenuebernahmeZeitpunkt");
      }


             if (!isSeitLadenVeraendertDatenuebernahmeZeitpunkt) {
          isSeitLadenVeraendertDatenuebernahmeZeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertDatenuebernahmeZeitpunkt){
           wertNachLadenDatenuebernahmeZeitpunkt=this.datenuebernahmeZeitpunkt;
         }
       }
      

       this.datenuebernahmeZeitpunkt = datenuebernahmeZeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu DateiImport
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "DATEI_IMPORT_ID", referencedColumnName="DATEI_IMPORT_ID"))
  protected de.ivu.elect.business.datei.entity.DateiImport dateiImport;

  /**
   * 
   */
  @Override
  public void setDateiImport(@javax.annotation.Nullable  de.ivu.elect.business.datei.entity.DateiImport dateiImport){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dateiImport
    , dateiImport);

    attributeChanged |= thisAttributChanged;

    hasChangedDateiImport |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("dateiImport");
    }

    this.dateiImport = dateiImport;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.datei.entity.DateiImport getDateiImport(){
    return this.dateiImport;
  }

  @javax.persistence.Transient
  protected boolean hasChangedDateiImport = false;

  public boolean hasChangedDateiImport(){
    return hasChangedDateiImport;
  }

  /**
   * Beziehung (unidirektional) zu WvpBenutzer
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WVP_BENUTZER_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer wvpBenutzer;

  /**
   * 
   */
  @Override
  public void setWvpBenutzer(@javax.annotation.Nullable  de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer wvpBenutzer){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wvpBenutzer
    , wvpBenutzer);

    attributeChanged |= thisAttributChanged;

    hasChangedWvpBenutzer |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wvpBenutzer");
    }

    this.wvpBenutzer = wvpBenutzer;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer getWvpBenutzer(){
    return this.wvpBenutzer;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWvpBenutzer = false;

  public boolean hasChangedWvpBenutzer(){
    return hasChangedWvpBenutzer;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WvpWahlvorschlagDaten:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WvpWahlvorschlagDaten other){
                             other.bericht = this.bericht;
                                other.daten = this.daten;
                                other.datenuebernahmeVersion = this.datenuebernahmeVersion;
                                other.datenuebernahmeZeitpunkt = this.datenuebernahmeZeitpunkt;
           
  other.setDateiImport(this.getDateiImport());
  other.setWvpBenutzer(this.getWvpBenutzer());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WvpWahlvorschlagDaten.class)){
        copyEntityAttributesUsingSetter((WvpWahlvorschlagDaten) other.castTo(WvpWahlvorschlagDaten.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WvpWahlvorschlagDaten: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WvpWahlvorschlagDaten other){
               other.setBericht(this.bericht);
                  other.setDaten(this.daten);
                  other.setDatenuebernahmeVersion(this.datenuebernahmeVersion);
                  other.setDatenuebernahmeZeitpunkt(this.datenuebernahmeZeitpunkt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WvpWahlvorschlagDaten other){
                       if (hasChangedBericht) {
        other.setBericht(this.bericht);
      }
                             if (hasChangedDaten) {
        other.setDaten(this.daten);
      }
                             if (hasChangedDatenuebernahmeVersion) {
        other.setDatenuebernahmeVersion(this.datenuebernahmeVersion);
      }
                             if (hasChangedDatenuebernahmeZeitpunkt) {
        other.setDatenuebernahmeZeitpunkt(this.datenuebernahmeZeitpunkt);
      }
             }





    @javax.persistence.Transient
    private transient WvpWahlvorschlagDatenTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WvpWahlvorschlagDatenTK getWvpWahlvorschlagDatenTK(){
    if (tkCache==null) {
    tkCache = new WvpWahlvorschlagDatenTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWvpWahlvorschlagDatenTK();
    }

  @Override
  public WvpWahlvorschlagDatenUK getUk(){
    return getWvpWahlvorschlagDatenUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WvpWahlvorschlagDaten.class;
  }

public WvpWahlvorschlagDatenUK getWvpWahlvorschlagDatenUK(){

   return  new WvpWahlvorschlagDatenUK(



  );
}

  @javax.persistence.Transient
  private transient WvpWahlvorschlagDatenProperties properties;

  public WvpWahlvorschlagDatenProperties getProperties(){
    if (properties == null) {
      properties = new WvpWahlvorschlagDatenProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WvpWahlvorschlagDatenProperties getWvpWahlvorschlagDatenProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WvpWahlvorschlagDatenConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                     
      if (werteVorher.containsKey(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_VERSTION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_VERSTION_EINZAHL);

        datenuebernahmeVersion =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_ZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_ZEITPUNKT_EINZAHL);

        datenuebernahmeZeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                if (isSeitLadenVeraendertDatenuebernahmeVersion) {
      result.put(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_VERSTION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenDatenuebernahmeVersion , datenuebernahmeVersion));
    }
                            if (isSeitLadenVeraendertDatenuebernahmeZeitpunkt) {
      result.put(WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_ZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenDatenuebernahmeZeitpunkt , datenuebernahmeZeitpunkt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                      isSeitLadenVeraendertDatenuebernahmeVersion = false;
      wertNachLadenDatenuebernahmeVersion = null;
                          isSeitLadenVeraendertDatenuebernahmeZeitpunkt = false;
      wertNachLadenDatenuebernahmeZeitpunkt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WVP_WAHLVORSCHLAG_DATEN";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "WvpWahlvorschlagDaten";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpWahlvorschlagDatenConstants.BERICHT_MAX_LENGTH ,  bericht, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_BERICHT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(daten, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATEN_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpWahlvorschlagDatenConstants.DATEN_MAX_LENGTH , 1 ,  daten, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATEN_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(datenuebernahmeVersion, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_VERSTION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_VERSTION_MAX_VALUE, WvpWahlvorschlagDatenConstants.DATENUEBERNAHME_VERSTION_MIN_VALUE, datenuebernahmeVersion, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_VERSTION_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(datenuebernahmeZeitpunkt, this, WvpWahlvorschlagDatenConstants.MESSAGE_KEY_DATENUEBERNAHME_ZEITPUNKT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
